leetcode:399. Evaluate Division

Equations are given in the format A / B = k, where A and B are variables represented as strings, and k is a real number (floating point number). Given some queries, return the answers. If the answer does not exist, return -1.0.

Example:
Given a / b = 2.0, b / c = 3.0.
queries are: a / c = ?, b / a = ?, a / e = ?, a / a = ?, x / x = ? .
return [6.0, 0.5, -1.0, 1.0, -1.0 ].

The input is: vector

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public class Solution {

    static boolean[][] vis = null;
    static double[][] graph;

    public double[] calcEquation(String[][] equations, double[] values, String[][] queries) {
        double[] ans = new double[queries.length];
        HashMap<String, Integer> map = new HashMap<String, Integer>();
        int index = 0;
        index = this.map(map, index, equations);
//      index = this.map(map, index, queries);

        graph = new double[index][index];
        vis = new boolean[index][index];
        for (int i = 0; i < graph.length; ++i) {
            Arrays.fill(graph[i], -1);
        }
        index = 0;
        for (String[] s : equations) {
            int a = map.get(s[0]);
            int b = map.get(s[1]);
            graph[a][b] = values[index];
            graph[b][a] = 1.0 / values[index];
            ++index;
        }
        for(int i = 0; i < graph.length; ++i){
            graph[i][i] = 1.0;
            vis[i][i] = true;
            dfs(i, i, graph[i][i]);
        }
        for(int i = 0 ; i < graph.length; ++i){
            System.out.println(Arrays.toString(graph[i]));
        }
        index = 0;
        for(String[] s : queries){
            Integer a = map.get(s[0]);
            Integer b = map.get(s[1]);
            if(a == null || b == null){
                ans[index++] = -1;
                continue;
            }
            ans[index ++] = graph[a][b];
        }
        return ans;
    }

    public static void dfs(int a, int b, double value) {
        for(int i = 0; i < graph.length; ++i){
            if(graph[b][i] > 0 && !vis[a][i]){
                vis[a][i] = true;
                graph[a][i] = value * graph[b][i];
                dfs(a, i, graph[a][i]);
            }
        }
    }

    private int map(Map<String, Integer> map, int index, String[][] equations) {
        for (String[] ss : equations) {
            String a = ss[0];
            String b = ss[1];
            if (map.get(a) == null) {
                map.put(a, index++);
            }
            if (map.get(b) == null) {
                map.put(b, index++);
            }
        }
        return index;
    }

    public static void main(String[] args) {
        String[][] equations= new String[][]{{"a", "b"}, {"b", "c"}};
        double values[] = new double[]{2, 3};
        String[][] queries = { {"a", "c"}, {"b", "a"}, {"a", "e"}, {"a", "a"}, {"x", "x"} };
        Solution s = new Solution();
        double[] ans = s.calcEquation(equations, values, queries);
        System.out.println(Arrays.toString(ans));
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
给定一个整数数组 nums 和一个目标值 target,要求在数组中找出两个数的和等于目标值,并返回这两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回这两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值